#import "MDNSDelegate.h"

@interface MDNSDelegate()
@end

@implementation MDNSDelegate {
    FlutterEventSink _eventSink;
}

-(FlutterError *_Nullable)onListenWithArguments:(id _Nullable)arguments eventSink:(FlutterEventSink)events {
    _eventSink = events;
    return nil;
}

-(FlutterError *_Nullable)onCancelWithArguments:(id _Nullable)arguments {
    return nil;
}

-(void)onDiscoveryStopped {
    _eventSink(@{ @"method": @"onDiscoveryStopped" });
}

-(void)onDiscoveryStarted {
    _eventSink(@{ @"method": @"onDiscoveryStarted" });
}

-(void)onServiceFound:(NSNetService* )service {
    _eventSink([MDNSDelegate serviceToDictionary:service method:@"onServiceFound"]);
}

-(void)onServiceResolved:(NSNetService* )service {
    _eventSink([MDNSDelegate serviceToDictionary:service method:@"onServiceResolved"]);
}

-(void)onServiceRemoved:(NSNetService* )service {
    _eventSink([MDNSDelegate serviceToDictionary:service method:@"onServiceRemoved"]);
}

#pragma Private Methods
+(NSDictionary* )serviceToDictionary:(NSNetService* )aNetService method:(NSString* )method {
    NSData* txtdata = [aNetService TXTRecordData];
    NSDictionary* dict = [NSNetService dictionaryFromTXTRecordData:txtdata];
    return @{
        @"method": method,
        @"txt": nil == dict ? [NSMutableDictionary dictionary] : dict,
        @"name": nil == [aNetService name] ? @"" : [aNetService name],
        @"type": nil == [aNetService type] ? @"" : [aNetService type],
        @"hostName": nil == [aNetService hostName] ? @"" : [aNetService hostName],
        @"address": nil == [aNetService addresses] ? @[] : [aNetService addresses],
        @"port": [NSNumber numberWithLong:[aNetService port]]
    };
}

@end
